"{ Package: 'jv:libgdbs' }"

Magritte::MAAccessor subclass:#GDBMAPropertyAccessor
	instanceVariableNames:'name'
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Support'
!

!GDBMAPropertyAccessor class methodsFor:'instance-creation'!

forPropertyNamed: aString
    ^ self new
        name: aString;
        yourself

    "Created: / 23-09-2014 / 22:19:02 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GDBMAPropertyAccessor class methodsFor:'testing'!

isAbstract
    ^ false

    "Created: / 23-09-2014 / 22:38:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GDBMAPropertyAccessor methodsFor:'accessing'!

name
    ^ name
!

name:aString
    name := aString.
! !

!GDBMAPropertyAccessor methodsFor:'model'!

read: object

    | nmXlated names index properties |

    nmXlated := (name includes: $-) ifTrue:[ name copyReplaceAll: $- with: $_] ifFalse:[ name ].
    index := (names := object class allInstVarNames) indexOf: nmXlated.
    index ~~ 0 ifTrue:[ 
        ^ object instVarAt: index.
    ].
    index := names indexOf: #properties.
    index ~~ 0 ifTrue:[ 
        properties := object instVarAt: index.
        properties notNil ifTrue:[ 
            ^ properties at: name ifAbsent:[ nil ]
        ].
    ].
    ^ nil

    "Created: / 23-09-2014 / 22:15:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

write: value to: object

    | nmXlated names index properties |

    nmXlated := (name includes: $-) ifTrue:[ name copyReplaceAll: $- with: $_] ifFalse:[ name ].
    index := (names := object class allInstVarNames) indexOf: nmXlated.
    index ~~ 0 ifTrue:[ 
        object instVarAt: index put: value.
    ] ifFalse:[
        index := names indexOf: #properties.
        index ~~ 0 ifTrue:[ 
            properties := object instVarAt: index.
            properties isNil ifTrue:[ 
                properties := Dictionary new.
                object instVarAt: index put: properties.
            ].
            properties at: name put: value.
        ].
    ].

    "Created: / 23-09-2014 / 22:16:09 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

