"{ Package: 'jv:libgdbs' }"

GDBMICommand subclass:#GDBMI_var_delete
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core-Commands-MI'
!

!GDBMI_var_delete class methodsFor:'documentation'!

documentation
"
The `-var-delete' Command
-------------------------

Synopsis
........

      -var-delete [ -c ] NAME

   Deletes a previously created variable object and all of its children.
With the `-c' option, just deletes the children.

   Returns an error if the object NAME is not found.


"
! !

!GDBMI_var_delete methodsFor:'accessing'!

operation
	^ 'var-delete'
! !

