"{ Package: 'jv:libgdbs' }"

Object subclass:#GDBTransientDataHolder
	instanceVariableNames:'debugger factory value seqno'
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Private'
!

!GDBTransientDataHolder class methodsFor:'instance creation'!

debugger: aGDBDebugger factory: aBlock
    ^ self new setDebugger: aGDBDebugger factory: aBlock

    "Created: / 17-09-2014 / 22:08:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GDBTransientDataHolder methodsFor:'accessing'!

value
    (value notNil and:[debugger currentInferiorStateSequnceNumber == seqno]) ifTrue:[ 
        ^ value.
    ].
    value := factory value.
    ^ value

    "Created: / 17-09-2014 / 22:06:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!GDBTransientDataHolder methodsFor:'initialization'!

setDebugger: aGDBDebugger factory: aBlock
    debugger := aGDBDebugger.
    factory := aBlock.

    "Created: / 17-09-2014 / 22:08:47 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

