"{ Package: 'jv:libgdbs' }"

GDBMICommand subclass:#GDBMI_inferior_tty_set
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core-Commands-MI'
!

!GDBMI_inferior_tty_set class methodsFor:'documentation'!

documentation
"
The `-inferior-tty-set' Command
-------------------------------

Synopsis
--------

     -inferior-tty-set /dev/pts/1

   Set terminal for future runs of the program being debugged.

{No value for `GDBN'} Command
-----------------------------

The corresponding {No value for `GDBN'} command is `set inferior-tty'
/dev/pts/1.

Example
-------

     (gdb)
     -inferior-tty-set /dev/pts/1
     ^done
     (gdb)


"
! !

!GDBMI_inferior_tty_set methodsFor:'accessing'!

operation
	^ 'inferior-tty-set'
! !

