"{ Package: 'jv:libgdbs' }"

GDBMICommand subclass:#GDBMI_stack_select_frame
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'GDB-Core-Commands-MI'
!

!GDBMI_stack_select_frame class methodsFor:'documentation'!

documentation
"
The `-stack-select-frame' Command
---------------------------------

Synopsis
........

      -stack-select-frame FRAMENUM

   Change the selected frame.  Select a different frame FRAMENUM on the
stack.

   This command in deprecated in favor of passing the `--frame' option
to every command.

{No value for `GDBN'} Command
.............................

The corresponding {No value for `GDBN'} commands are `frame', `up',
`down', `select-frame', `up-silent', and `down-silent'.

Example
.......

     (gdb)
     -stack-select-frame 2
     ^done
     (gdb)


"
! !

!GDBMI_stack_select_frame methodsFor:'accessing'!

operation
	^ 'stack-select-frame'
! !

